Template.photo.helpers({
  whose: function() {
    if(!Meteor.user())
      return 'nobody';

    var owner = this.owner;

    if(Utils.me() == owner)
      return 'Your';
    else
      return owner + '\'s';
  },
});

Template.photo.events({
  'click .delete-photo': function(event, template) {
    event.preventDefault();
    
    if(this.objid != null) {
      var me = Utils.me();
      var myMasterKey = Trustore.Keys.get('master');
      var myPrivateKey = Trustore.Keys.getAsymPrivate();
      var photoid = this.objid;
      var albumid = this.albumId;

      console.log("DELETING PHOTO: DELETER=" + me + ", PHOTO ID=" + photoid);
      try {
        Album.deletePhoto(albumid, me, myMasterKey, myPrivateKey, photoid);
        // console.log("REDIRECT: " + "/album/" + this.parent.owner + "/" + albumid);
        // Router.go("/album/" + this.parent.owner + "/" + albumid);
        // console.log("REDIRECT WTF: " + "/album/" + this.parent.owner + "/" + albumid);
      } catch (err) {
        console.log("ERROR: Do not have permission to delete this photo.");
      }
    } else {
      console.log('ERROR: Must have object id of photo to delete.');
    }
  },
});
