Package.describe({
  summary: 'Crypto Utilities',
  version: '0.0.1',
  name: 'crypto-utils'
});

Package.on_use(function (api) {
  // normally the server does not need crypto access, but we need
  // it for creating data for testing
  where = ['client', 'server']; 

  api.use(['ejson', 'underscore']);

  api.add_files(['elliptic.js'], where);
  api.add_files(['crypto-utils.js'], where);

  api.export("CryptoUtils");
});
