// Publishing should be outside Meteor.startup()

Meteor.publish('UserProfiles', function () { return UserProfiles.find(); });
/*
  if(this.userId) {
    console.log('publishing user profiles for userId: ' + this.userId);
    // this errors with 'Exception from sub TKAZFk9CT7qoW3Qct undefined' for some odd reason
    //console.log('this: ' + EJSON.stringify(this)); 

    //var user =  Meteor.users.findOne({ _id: this.userId }, { fields: { username: 1 } });
    //console.log('user: ' + EJSON.stringify(user));
    var username = Utils.getUserName(this.userId);
    var friends_and_user = Meteor.users.findOne(this.userId).profile.friends;

    if (friends_and_user === null || typeof(friends_and_user) === 'undefined')
        friends_and_user = [username];
    else
        friends_and_user.push(username);
    
    var profile = UserProfiles.find({ username: { $in: friends_and_user }});

    //console.log('username: ' + username);
    //console.log('profile: ' + EJSON.stringify(profile.fetch())); // WARNING: cannot stringify cursor obtained with find(). maybe they are circular...

    return profile;
  } else {
    // apparently this should be called when data is ready to 
    // be returned or when there's no data. 
    // See http://docs.meteor.com/#/full/meteor_loggingin
    this.ready(); 
  }
});
*/      // Doesn't publish properly. Unable to get friends' profiles. Figure out.

Meteor.publish('Albums', function () { return Albums.find(); });

Meteor.publish('userData', function () {
  if(this.userId) {
    return Meteor.users.find({ _id: this.userId }, { fields: { username: 1, emails: 1, profile: 1 } });
  } else {
    this.ready();
  }
});

// we publish all the other user's usernames, so we can use them in
// our search feature
Meteor.publish('allUserData', function () {
    //console.log('publishing all user\'s public keys...');
    // FIXME: This is not ideal that anyone can query the friend requests of another user.
    // We can fix this by having a Meteor method for Friends.isFriendRequestSent, but the
    // asynchronicity will kill us.
    return Meteor.users.find({ }, { fields: { username: 1, 'profile.publicKey': 1, 'profile.friendRequests': 1, 'profile.profileId': 1, 'profile.albumIds': 1 } });
});

// FIXME: you can maybe filter to only publish trees/nodes/indices of ACLs you own or of ACLs you are in
Meteor.publish('allAclTrees', function () { return AclTrees.find({}); });
Meteor.publish('allAclNodes', function () { return AclNodes.find({}); });
Meteor.publish('allAclIndexes', function () { return AclIndexes.find({}); });

Meteor.publish('allHashChains', function () { return HashChains.find({}); });
Meteor.publish('allHashChainNodes', function () { return HashChainNodes.find({}); });
Meteor.publish('allDialogues', function () { return Dialogues.find({}); });
Meteor.publish('allQuacks', function () { return Quacks.find({}); });
Meteor.publish('allUserConvos', function () { return UserConvos.find({}); });
