Template.newconversation.helpers({
  usernames: function() {
    // Returns concatenation of usernames
    return _.reduceRight(_.pluck(this.friends, 'username'), function(a, b) { return a + ', ' + b });
  },
});

Template.newconversation.events({
  'submit .new-conversation': function(event, template) {
    event.preventDefault();
    console.log('Sending message...');

    var title = template.find('#title').value;
    var message = template.find('#message').value;

    if(!title || title.length == 0) {
      // TODO: error
    }

    if(!message || message.length == 0) {
      // TODO: error
    }
    
    // Returns a Dialogue object
    var r = Dialogue.createConversation(this.owner, this.ownerMasterKey, this.ownerPrivateKey, this.friends, title);
    var convo = r.dialogue;
    convo.addQuack(Quack.create('message', this.owner, 1, message, convo), r.contentKey, this.ownerPrivateKey);

    Router.go('/conversations');
  },
});
