Accounts.onCreateUser(function (options, user) {
  //console.log('Accounts.onCreateUser() called on server!');
  //console.log(' * user: ' + EJSON.stringify(user, { indent: false }));
  //console.log(' * options: ' + EJSON.stringify(options, { indent: false }));
  //console.log(' * user.username: ' + user.username);
  //console.log(' * options.profile: ' + EJSON.stringify(options.profile));

  // the default onCreateUser used to do this, so we need to replicate it in
  // our custom onCreateUser
  if(options.profile)
    user.profile = options.profile

  return user;

  // NOTE: this function completing does not mean a user has been registered!
  // apparently, this gets called on failed registrations as well (such as when
  // an email address already exists)
});

Accounts.onLogin(function (attempt) {
  console.log('successful login attempt');//: ' + EJSON.stringify(attempt, { indent: false }));
});

Accounts.onLoginFailure(function (attempt) {
  console.log('failed login attempt');//: ' + EJSON.stringify(attempt, { indent: false }));
})
