TestCrypto = {
  run: function() {
    TestCrypto.testHash();
  },

  testHash: function() {
    var goodTests = [
      { s: 'lol', h: '07123e1f482356c415f684407a3b8723e10b2cbbc0b8fcd6282c49d37c9c1abc' },
      // repeat, to make sure rehashing works as well (no weird state that needs cleanup)
      { s: 'lol', h: '07123e1f482356c415f684407a3b8723e10b2cbbc0b8fcd6282c49d37c9c1abc' },
      { s: 'friend.me', h: '038e5eb78e2d6d726915723a22b4a58375e817e1be1cff0a81e5783a2a4bd460' },
    ];

    for(var i = 0; i < goodTests.length; i++) {
      assert.equal(goodTests[i].h, CryptoUtils.hash(goodTests[i].s));
    } 

    var badTests = [
      { s: 'lol', h: 'lolz4244aa43ddd6e3ef9e64bb80f4ee952f68232aa008d3da9c78e3b627e5675c8' },
      { s: 'friend.not.me', h: '038e5eb78e2d6d726915723a22b4a58375e817e1be1cff0a81e5783a2a4bd460' },
    ];

    for(var i = 0; i < badTests.length; i++) {
      assert.notEqual(badTests[i].h, CryptoUtils.hash(badTests[i].s));
    } 

  },
}
